<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1"
		xmlns="http://www.ivoa.net/xml/ADQL/v0.7.4" xmlns:ad="http://www.ivoa.net/xml/ADQL/v0.7.4"
		xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	
	<!-- 
		Stylesheet to convert ADQL/x v0.7.4 to an SQL string
		Version 1.1 - first release - July 8, 2005
                MySQL extension of the stylesheet
		Aurelien STEBE - ESAC - ESA
		Aurelien.Stebe@sciops.esa.int
	 -->
	
	<xsl:import href="ADQL074toSQL.xsl"/>
	
	<xsl:output method="text" indent="no"/>
	
	<!-- the 'select' template -->
	
	<xsl:template match="ad:Select">
		<xsl:text>SELECT </xsl:text>
		<xsl:apply-templates select="ad:Allow"/>
		<xsl:apply-templates select="ad:SelectionList"/>
		<xsl:apply-templates select="ad:From"/>
		<xsl:apply-templates select="ad:Where"/>
		<xsl:apply-templates select="ad:GroupBy"/>
		<xsl:apply-templates select="ad:Having"/>
		<xsl:apply-templates select="ad:OrderBy"/>
		<xsl:apply-templates select="ad:Restrict"/>
	</xsl:template>
	
	<!-- the "main" elements -->
	
	<xsl:template match="ad:OrderBy">
		<xsl:variable name="list">
			<xsl:for-each select="ad:Item">
				<xsl:apply-templates select="ad:Order"/>
				<xsl:apply-templates select="ad:Expression"/>
				<xsl:text>, </xsl:text>
			</xsl:for-each>
		</xsl:variable>
		<xsl:text>ORDER BY </xsl:text>
		<xsl:value-of select="substring($list, 1, string-length($list)-2)"/>
		<xsl:text> </xsl:text>
	</xsl:template>
	<xsl:template match="ad:Order">
                <xsl:if test="@Direction = 'DESC'">
                        <xsl:text>-</xsl:text>
                </xsl:if>
	</xsl:template>
	
	<!-- the 'expressionType' templates -->
	
	<xsl:template match="ad:Restrict">
		<xsl:text>LIMIT </xsl:text>
		<xsl:value-of select="@Top"/>
		<xsl:text> </xsl:text>
	</xsl:template>
	
</xsl:stylesheet>
